/*Programm Lftersteuerung
Dateiname: test.c
Ersteller: R Gassmann
Funktion: Gemss Prfung in der HST
*/

// Einbindung der Bibliotheken

#include <stm32f10x_cl.h>   //Mikrokontrollertyp
#include "P0P1Touch.h"			//Header P0P1-defintionen 

#define TST_CLOSE		0x01
#define TST_BLOCK		0x08
#define TST_RST			0x10
#define TST_OPEN  	0x80

#define LED_CLOSED	0xFF
#define LED_OPENED	0x01

int main(void){ 
	struct {
		char act;
		char old;
		char flk;
		char flk_pos;
		char flk_neg;
	} tst;
	

	enum {Valve_Opened, Valve_Closing, Valve_Closed, Valve_Opening, Valve_Blocked} state = Valve_Opened;
	unsigned char led = 0;
	unsigned char pos = 1; // Valve Position
	
	unsigned char blink = 0;
	
	unsigned long loop_cnt = 1200000;
	char sec_pulse;
	
	tst.act =0;
	tst.old =0;
	

	InitP0P1Touch(3);						//Touchscreen initialisieren
	while(1){
		tst.act = P0;										//Einlesen
		tst.flk = tst.act ^ tst.old;				//Flanken erkennen
		tst.flk_pos = tst.flk & tst.act;				//Positive Flanken erkennen
		tst.flk_neg = tst.flk & tst.old;		//Negative Flanken erkennen
		tst.old = tst.act;							//Update tst_old
		
		led = 0;
		
		//paste your code here
		switch(state) {
			case Valve_Opened:
				led = LED_OPENED;  // ANZEIGE Update
				if ( tst.flk_pos & TST_CLOSE ) {
					state = Valve_Closing;
				}
			break;
			case Valve_Closing:
				// ANZIEGE Update
				if ( sec_pulse ) {
					pos += 1;
				}
				
				led = ( 0xFF >> ( 8 - pos ) ); 
				
				// STATE Update
				if ( pos == 8 ) {
					state = Valve_Closed;
				}
				if ( tst.flk_pos & TST_BLOCK ) {
					state = Valve_Blocked;
				}
			break;
			case Valve_Closed:
				led = LED_CLOSED;  // ANZEIGE Update
				if ( tst.flk_pos & TST_OPEN ) {
					state = Valve_Opening;
				}
			break;
			case Valve_Opening:
				// ANZIEGE Update
				if ( sec_pulse ) {
					pos -= 1;
				}
				
				led = ( 0xFF >> ( 8 - pos ) ); 
				
				// STATE Update
				if ( pos == 1 ) {
					state = Valve_Opened;
				}
				if ( tst.flk_pos & TST_BLOCK ) {
					state = Valve_Blocked;
				}
			break;
			case Valve_Blocked:
				// ANZIEGE Update
				if ( sec_pulse ) blink = !blink;
			
				if ( blink ) {
					led = ( 0xFF >> ( 8 - pos ) );  
				}
				
				// STATE Update
				if ( tst.flk_pos & TST_RST ) {
					pos = 1;
					state = Valve_Opened;
				}
			break;
		}
		
		P1 = led;										//Ausgabe
		
		sec_pulse = 0;
		
		if ( loop_cnt ) {
			loop_cnt--;
		} else {
			loop_cnt = 1200000;
			sec_pulse = 1;
		}
		
	}
}
